import React from 'react';
import { useNamedRouting } from './hooks';
export function withNamedRouting(Component) {
    const WrappedComponent = (props) => {
        const namedRouting = useNamedRouting();
        return (React.createElement(Component, Object.assign({}, props, { namedRouting: namedRouting })));
    };
    WrappedComponent.displayName = `WithRouting(${Component.displayName || Component.name})`;
    return WrappedComponent;
}
