"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_router_1 = require("react-router");
const tiny_invariant_1 = __importDefault(require("tiny-invariant"));
const hooks_1 = require("./hooks");
exports.NamedSwitch = ({ location: locationFromProps, children }) => {
    const context = hooks_1.useNamedRouting();
    tiny_invariant_1.default(context, 'You should not use <NamedSwitch> outside a <NamedRouter>');
    const location = locationFromProps || context.location;
    return (react_1.default.createElement(react_router_1.Route, null, ({ match: parentMatch }) => {
        let element = null;
        let match = null;
        react_1.default.Children.forEach(children, (child) => {
            if (match === null && react_1.default.isValidElement(child)) {
                element = child;
                const path = child.props.name ? context.getRawPath(child.props.name) : child.props.from;
                const route = child.props.name ? context.getRoute(child.props.name) : {};
                match = path
                    ? react_router_1.matchPath(location.pathname, Object.assign(Object.assign(Object.assign({}, route), child.props), { path }))
                    : parentMatch;
            }
        });
        return match && element
            ? react_1.default.cloneElement(element, { location, computedMatch: match })
            : null;
    }));
};
exports.NamedSwitch.displayName = 'NamedSwitch';
