import { RouteChildrenProps } from 'react-router';
import { RouteProps } from 'react-router-dom';
import { LocationDescriptorObject } from 'history';
export interface CustomNamedRouteConfig {
}
export declare type NamedRouteConfig = CustomNamedRouteConfig & Omit<RouteProps, 'children'> & {
    name?: string | string[];
    path?: string;
    routes?: NamedRouteConfig[];
};
export declare type ExtendedRouteConfig = NamedRouteConfig & {
    parents: string[];
    regex?: RegExp;
};
export declare const buildRoutePath: (map: Map<string, ExtendedRouteConfig>, name: string, params?: any) => string;
export declare const mapRoutes: (routes: NamedRouteConfig[], basename?: string, parents?: string[], map?: Map<string, ExtendedRouteConfig>) => Map<string, ExtendedRouteConfig>;
export declare type NamedLocation = Omit<LocationDescriptorObject, 'pathname'> & {
    name: string;
};
export declare class RoutingContext {
    protected readonly routesMap: Map<string, ExtendedRouteConfig>;
    protected readonly routerContext: Partial<RouteChildrenProps>;
    readonly currentRoute: ExtendedRouteConfig | null;
    readonly params: {
        [key: string]: string;
    };
    readonly exactParams: {
        [key: string]: string;
    };
    readonly location: import("history").Location<any>;
    readonly history: import("history").History<any>;
    private static extractParams;
    constructor(routesMap: Map<string, ExtendedRouteConfig>, routerContext?: Partial<RouteChildrenProps>);
    match: (pathname: string, matchAll?: boolean | undefined) => ExtendedRouteConfig | null;
    getPath: <TParams>(name: string, params?: TParams | undefined) => string;
    getRawPath: (name: string) => string | (string[] & string);
    getRoute: (name: string) => ExtendedRouteConfig;
    push: (location: string | NamedLocation, params?: {
        [key: string]: string;
    } | undefined) => void;
    replace: (location: string | NamedLocation, params?: {
        [key: string]: string;
    } | undefined) => void;
}
export declare type RoutingContextArg = Omit<Partial<RouteChildrenProps<any, any>>, 'location'> & {
    location: string | RouteChildrenProps<any, any>['location'];
};
export declare const buildRoutingContext: (routes: NamedRouteConfig[], routerContext?: RoutingContextArg | undefined, basename?: string | undefined) => RoutingContext;
